var CustomCharactersFgInput = {
  readingCode: false,
  prefMeta: 1,
  prefChar: ".",
  prefChar2: ",",
  CustomCharacters: ["03C0", "03C1", "03C2", "03C3", "03C4", "03C5", "03C6", "03C7", "03C8", "03C9"],

  ChildNodeCleanUp: function (localParentNode) {
    while (localParentNode.firstChild) {
      if (localParentNode.firstChild.hasChildNodes()) {
        CustomCharactersFgInput.ChildNodeCleanUp(localParentNode.firstChild);
      }
      localParentNode.removeChild(localParentNode.firstChild);
    }
  },

  KeyPress: function (triggerEvent) {
    var returnValue = true;
    var tempIdx = 0;
    var tempText = "";
    var tempNode = null;
    if (CustomCharactersFgInput.readingCode == true) {
      var currentChar = triggerEvent.key;
      returnValue = false;
      if ((currentChar == "Esc") || (currentChar == "Escape")) {
        CustomCharactersFgInput.readingCode = false;
        tempNode = document.getElementById("CustomCharactersInputDIV");
        if (tempNode != null) {
          CustomCharactersFgInput.ChildNodeCleanUp(tempNode);
          tempNode.parentNode.removeChild(tempNode);
        }
        triggerEvent.preventDefault();
      } else {
        tempIdx = parseInt(currentChar);
        if ((tempIdx >= 0) && (tempIdx < 10)) {
          tempText = String.fromCharCode("0x"+CustomCharactersFgInput.CustomCharacters[tempIdx]);
          var localElement = document.activeElement;
          var localElementName = String(localElement.tagName).toUpperCase();
          if ((localElementName == "TEXTAREA") || (localElementName == "INPUT")) {
            var startPos = localElement.selectionStart;
            var endPos = localElement.selectionEnd;
            localElement.value = localElement.value.substring(0, startPos)+tempText+localElement.value.substring(endPos, localElement.value.length);
            localElement.selectionStart = startPos + tempText.length;
            localElement.selectionEnd = startPos + tempText.length;
          }
          triggerEvent.preventDefault();
        } else {
          returnValue = true;
        }
      }
    } else {
      // Checking to see if input has been triggered
      var metaState = 0;
      if (triggerEvent.ctrlKey == true) { metaState = metaState + 1;}
      if (triggerEvent.altKey == true) { metaState = metaState + 2;}
      if (metaState > 0) {
        if ((metaState == CustomCharactersFgInput.prefMeta) &&
            ((triggerEvent.key == CustomCharactersFgInput.prefChar) ||
            (triggerEvent.key == CustomCharactersFgInput.prefChar2))) {
          function useStoredSettings(retrievedSettings) {
            var tempIdx = 0;
            var tempItem = null;
            var listText = "";
            if (triggerEvent.key == CustomCharactersFgInput.prefChar2) {
              listText = "List 2";
              tempItem = retrievedSettings.ccCharSettings2;
              CustomCharactersFgInput.CustomCharacters = ["03A0", "03A1", "03A2", "03A3", "03A4", "03A5", "03A6", "03A7", "03A8", "03A9"];
            } else {
              listText = "List 1";
              tempItem = retrievedSettings.ccCharSettings;
            }
            if (Array.isArray(tempItem)) {
              var tempLength = tempItem.length;
              if (tempLength > 10) { tempLength = 10 };
              for (tempIdx = 0; tempIdx < tempLength; tempIdx++) {
                CustomCharactersFgInput.CustomCharacters[tempIdx] = tempItem[tempIdx];
              }
            }
            var cctempNode = document.getElementById("CustomCharactersInputDIV");
            if (cctempNode == null) {
              var cctempNode1 = document.createElement("div");
              cctempNode1.setAttribute("id","CustomCharactersInputDIV");
              cctempNode1.setAttribute("style","z-index:10; position:absolute; left:10px; top:10px; background-color:#ffffff; color:#000000; padding:5px;");
              var cctempNode2 = document.createElement("p");
              cctempNode2.setAttribute("id","CustomCharactersInputP1");
              cctempNode2.textContent = "Custom Characters "+listText+":";
              cctempNode1.appendChild(cctempNode2);
              cctempNode2 = document.createElement("ul");
              cctempNode2.setAttribute("style","list-style-type: none;");
              var cctempNode3 = null;
              for (tempIdx = 0; tempIdx < 10; tempIdx++) {
                cctempNode3 = document.createElement("li");
                tempText = String.fromCharCode("0x"+CustomCharactersFgInput.CustomCharacters[tempIdx]);
                cctempNode3.textContent = String(tempIdx) + " = " + tempText;
                cctempNode2.appendChild(cctempNode3);
              }
              cctempNode1.appendChild(cctempNode2);
              cctempNode2 = document.createElement("p");
              cctempNode2.setAttribute("id","CustomCharactersInputP2");
              cctempNode2.setAttribute("style","text-align: center;");
              cctempNode2.textContent = "Press Esc to close.";
              cctempNode1.appendChild(cctempNode2);
              document.body.appendChild(cctempNode1);
            }
          };
          function onError(e) {
            chrome.notifications.create({
              "type": "basic",
              "iconUrl": chrome.extension.getURL("icons/customcharacters-48.png"),
              "title": chrome.i18n.getMessage("RestoreErrorTitle"),
              "message": chrome.i18n.getMessage("RestoreErrorMessage")
            });
          };
          CustomCharactersFgInput.readingCode = true;
          triggerEvent.preventDefault(); returnValue = false;
          var ccStoredSettings = browser.storage.local.get();
          ccStoredSettings.then(useStoredSettings, onError);
        }
      }
    }
    return returnValue;
  }
};

window.addEventListener("keypress", function(e) { CustomCharactersFgInput.KeyPress(e); }, true);
